#include <vector>
#include <string>
#include <iostream>
#define ll long long

using namespace std;

int main()
{
	ll n, m; cin >> n >> m;
	vector<string> seats(n);
	vector<pair<ll, vector<ll>>> avnums;
	bool flag = true;
	ll available = 0;
	for (ll i = 0; i < n; i++) {
		string seat; cin >> seat;

		if (seat[0] != seat[5]) {
			if (m == 0) {
				flag = false;
				continue;
			}
			seat[0] = 'X';
			seat[5] = 'X';
			m--;
		}
		
		if (seat[1] != seat[4]) {
			if (m == 0) {
				flag = false;
				continue;
			}

			seat[1] = 'X';
			seat[4] = 'X';
			m--;
		}

		if (seat[2] != seat[3]) {
			if (m == 0) {
				flag = false;
				continue;
			}

			seat[2] = 'X';
			seat[3] = 'X';
			m--;
		}

		vector<ll> thisseat;
		for (ll j = 0; j < 6; j++) {
			if (seat[j] == '.') {
				thisseat.push_back(j);
				available++;
			}
		}
		//cout << "seat: " << seat << endl;
		//cout << "avlbl: ";
		//for (ll a : thisseat) cout << a << " ";
		//cout << endl << endl;
		avnums.push_back(make_pair(i, thisseat));
		seats[i] = seat;
	}

	if (!flag) {
		cout << "Impossible";
		return 0;
	}

	if (m == 0) {
		for (auto a : seats) cout << a << endl;
		return 0;
	}

	if (m % 2 == 1 || m > available) {
		cout << "Impossible";
		return 0;
	}

	for (auto a : avnums) {
		if (m == 0) break;
		ll i = a.first;
		vector<ll> nums = a.second;
		for (ll j : nums) {
			if (m == 0) break;
			seats[i][j] = 'X';
			m--;
			//cout << "doing seat " << i << " " << j << endl;
		}
	}

	for (auto a : seats) cout << a << endl;
	/*
	XX..XX
	X.XX.X
	......
	XX..XX
	
	*/
}